// Generated by CoffeeScript 1.12.7
(function() {
  var PropTypes, React, ReactDOM, Resizer, createClass, div;

  React = require('react');

  ReactDOM = require('react-dom-factories');

  createClass = require('create-react-class');

  PropTypes = require('prop-types');

  div = ReactDOM.div;

  Resizer = createClass({
    displayName: 'Resizer',
    propTypes: {
      className: PropTypes.string,
      handleClassName: PropTypes.string,
      direction: PropTypes.string,
      onResizeStart: PropTypes.func,
      onResize: PropTypes.func.isRequired,
      onResizeEnd: PropTypes.func
    },
    getDefaultProps: function() {
      return {
        className: '',
        handleClassName: '',
        direction: 'x'
      };
    },
    componentWillUnmount: function() {
      return this._removeListeners();
    },
    _startPosition: {
      x: 0,
      y: 0
    },
    _handleMouseMove: function(e) {
      var diff;
      e.preventDefault();
      if (this.props.direction === 'x') {
        diff = this._startPosition.x - e.clientX;
        if (diff !== 0) {
          this.props.onResize(this._startPosition.x - e.clientX);
        }
      }
      if (this.props.direction === 'y') {
        diff = this._startPosition.y - e.clientY;
        if (diff !== 0) {
          this.props.onResize(this._startPosition.y - e.clientY);
        }
      }
      return this._updateStartPosition(e);
    },
    _handleMouseDown: function(e) {
      var base;
      e.preventDefault();
      if (typeof (base = this.props).onResizeStart === "function") {
        base.onResizeStart(e);
      }
      this._updateStartPosition(e);
      window.addEventListener('mouseup', this._handleMouseUp);
      return window.addEventListener('mousemove', this._handleMouseMove);
    },
    _handleMouseUp: function(e) {
      var base;
      if (typeof (base = this.props).onResizeEnd === "function") {
        base.onResizeEnd(e);
      }
      return this._removeListeners();
    },
    _removeListeners: function() {
      window.removeEventListener('mouseup', this._handleMouseUp);
      return window.removeEventListener('mousemove', this._handleMouseMove);
    },
    _updateStartPosition: function(e) {
      this._startPosition.x = e.clientX;
      return this._startPosition.y = e.clientY;
    },
    render: function() {
      return div({
        className: "resizer " + this.props.className
      }, div({
        onMouseDown: this._handleMouseDown,
        className: "handle " + this.props.handleClassName
      }), this.props.children);
    }
  });

  module.exports = Resizer;

}).call(this);
